library ieee;
use ieee.std_logic_1164.all;

entity intnoise is
port
	(
	clock	: in	std_logic;
	enable	: in	std_logic;
	q		: out	std_logic
	);
end;

architecture rtl of intnoise is
constant LENGTH  : integer := 15000;


signal r:std_logic_vector(31 downto 1);
type state_t is (init_e,run_e);
signal state_s:state_t;

signal shiftreg:std_logic_vector(LENGTH downto 1);
signal clockint:std_logic;

begin

		process(clock)
		begin
			if rising_edge(clock) then
				if enable = '1' then
					case state_s is
					when init_e => 
						r <= (others => '1');
						state_s <= run_e;
					when run_e =>
						r <= r(30 downto 1) & (r(31) xor r(30) xor r(7) xor r(6));
					end case;
				end if;
			end if;
		end process;
		
		process(clock)
		begin
			if rising_edge(clock) then
				if enable = '1' then
					shiftreg <= shiftreg((LENGTH-1) downto 1) & r(31);
					q <= shiftreg(LENGTH);
				else
					q <= '1';
				end if;				
			end if;
		end process;
		
end;